' (C) Copyright wellCAM CCS Lublin, 1998
'
' MAKRO TabelkaListyCzesci.MCR
' Dodanie do rysunku tabelki do listy czci.
'
' Historia zmian:
' Data      Kto                 Co
' ========  ==================  ======================================
' 14.05.98  wellCAM             Pierwsza wersja
'
'
' Makro pozwala na dodanie do rysunku tabelki do listy czci.
' Makro to zawiera jedynie rozwizania przykadowe i moe by
' wykorzystane jako podstawa do stworzenia tabelki zgodnej z
' wasnymi wymogami.
'
' Makro jest dostosowane do uywania w rysunkach stworzonych 
' na bazie standardowych formatek PL_A4.ICT do PL_A0.ICT 
' dostarczanych z wersj instalacyjn programu. Ponadto zakada si, 
' e parametry polecenia LIC s ustawione w sposob standardowy, 
' w szczeglnoci prefiksy atrybutw listy czci rozpoczynaj si 
' od "LIS", numery kolejne poprzedzane s zerami (np. "LIS001").
' Dugoci poszczeglnych kolum tabeli s standardowe.
' W przypadku wykorzystywania innych formatek makro naley 
' odpowiednio przystosowa, zmieniajac wartoci niektrych zmiennych 
' w procedurze DrawTable().


'#Uses "def.mcr"

Sub Main
	Begin Dialog UserDialog 270,105,"Tabelka do listy czci"
		Text 20,28,160,14,"Liczba pozycji w licie:",.PosCntPmt
		TextBox 190,23,50,20,.PosCnt
		OKButton 30,70,90,21
		CancelButton 150,70,90,21
	End Dialog
	Dim dlg As UserDialog
	result = Dialog(dlg)
	If (-1 = result) Then
		Dim posCnt As Integer
		posCnt = Val(dlg.PosCnt)
		Call DrawTable(posCnt)
	End If
End Sub

' Procedura rysuje tabelke listy czesci o liczbie pozycji przekazanej w 'posCnt'
' Tabelka jest rysowana poczawszy od pozycji zaleznej od formatu rysunku
Sub DrawTable(posCnt As Integer)
	If (0 <> posCnt) Then
		Dim ortPntX, ortPntY As Double	' punkt orientacyjny tabelki
		Dim colCnt As Integer			' liczba kolumn
		Dim colWdt() As Double		' tablica z szerokosciami poszczegolnych kolumn (w mm)
		Dim colDsc() As String			' tablica z opisami poszczegolnych kolumn 
		Dim rowHgt As Double			' wysokosc jednego wiersza
		Dim stdTblWdt As Double		' standardowa szerokosc tabelki rysunkowej
		Dim stdMrgWdt As Double		' standardowa szerokosc marginesu arkusza
		Dim stdTblHgt As Double		' standardowa wysokosc tabelki rysunkowej
		Dim licTexHgt As Double		' wysokosc tekstu w tabelce listy czesci
		Dim licTexPen As Integer		' pisak tekstu w tabelce listy czesci
		Dim tblLinPen As Integer		' pisak linii rozdzielajacych wiersze i kolumny w tabelce listy czesci
		Dim lisAtrPrf As String			' prefiks nazw atrybutow przechowujacych dane do listy czesci
		
		' W tej czesci inicjowane sa zmienne od ktorych zalezy wyglad tabeli
		' Aby dopasowac tabelke do swoich potrzeb nalezy zmodyfikowac te wartosci 
		colCnt = 6
		
		stdTblWdt = 193.00
		stdMrgWdt = 5.0
		stdTblHgt = 50.1
		licTexHgt = 3.5
		licTexPen = 8					' pisak numer 8, "Tekst sredni", ze standardowej tabeli piskow
		dscTexPen = 8				' pisak numer 8, "Tekst sredni", ze standardowej tabeli piskow
		tblLinPen = 2					' pisak numer 2, "Linia cienka", ze standardowej tabeli piskow
		' standardowa szerokosc tabelki rysunkowej wynosi 193
		' suma szerokosci wszystkich kolumn tabelki powinn byc wiec 
		' rowniez rowna 193.00 mm
		ReDim colWdt(colCnt)			' ustal rozmiar tablicy
		colWdt(0) = 12.0
		colWdt(1) = 70.0
		colWdt(2) = 10.0
		colWdt(3) = 30.0
		colWdt(4) = 35.0
		colWdt(5) = 36.0
		
		ReDim colDsc(colCnt)			' ustal rozmiar tablicy
		colDsc(0) = "L.p."
		colDsc(1) = "Nazwa"
		colDsc(2) = "Il."
		colDsc(3) = "Materia"
		colDsc(4) = "Norma"
		colDsc(5) = "Wymiar"
		
		lisAtrPrf = "LIS"

		rowHgt = 6.0
		posCnt = posCnt + 1			' jeden dodatkowy wiersz na opisy
		InitApplication					' Inicjalizacja polaczenia z aktualnym rysunkiem
		ortPntX = Drawing.Width - stdMrgWdt - stdTblWdt
		ortPntY = stdMrgWdt + stdTblHgt
		
		Dim idx As Long				' indeks obiektu
	 	idx = Drawing.AddObject		'Stwrz nowy obiekt, pobierz jego indeks
	 	If (idx > 0) Then
			Dim col As Integer			' aktualny numer kolumny
			Dim row As Integer			' aktualny numer wiersza
			Dim tblWdt As Double		' szerokosc calej tabelki
			
			Drawing.OpenObject(idx)							' otwrz obiekt w celu dodania skladnikow
			Drawing.AddAttribute("Obiekt", "Tabelka Listy Czesci")	' Po tym atrybucie tabelka jest rozpoznawana
			Drawing.SetPointORD(ortPntX, ortPntY)				' punkt orientacyjny obiektu
			
			' oblicz szerokosc calej tabelki
			tabWdt = 0.0
			For col = 0 To colCnt - 1
				tabWdt = tabWdt + colWdt(col)
			Next col
			
			' Kresl odcinki oddzielajace wiersze
			For row = 1 To posCnt
				Drawing.AddLine ortPntX, ortPntY + row * rowHgt, ortPntX + tabWdt, ortPntY + row * rowHgt, tblLinPen, -1
			Next row
			
			Dim colPos As Double		' aktualna pozycja odcinka oddzielajacego wiersze
			colPos = ortPntX
			' Kresl odcinki oddzielajace kolumny
			Drawing.AddLine colPos, ortPntY, colPos, ortPntY + posCnt *  rowHgt, 2, -1
			For col = 0 To colCnt - 2
				colPos = colPos + colWdt(col)
				Drawing.AddLine colPos, ortPntY, colPos, ortPntY + posCnt *  rowHgt, 2, -1
			Next col
			
			Dim verDst As Double		' odstep tekstu od odcinkow rozdzielajacych wiersze
			verDst =(rowHgt -  licTexHgt) / 2.0
			Drawing.SetTextParameters licTexHgt, 2.5, 0, 1, 0
			' dodaj teksty tlumaczone na atrybuty rysunkowe
			For row = 1 To posCnt - 1
				Drawing.AddText ortPntX + 3.0, ortPntY + row * rowHgt + verDst , "$$" + lisAtrPrf + Format(row, "000"), licTexPen, -1
			Next row
			
			' Tekst pochylony 3.5/2.5 justyfikacja srodek-dol
			Drawing.SetTextParameters licTexHgt, 2.5, 0, 4, 1
			' dodaj teksty opisujace tabelke listy czesci 
			Dim dscPos As Double
			dscPos = ortPntX
			colPos = ortPntX
			For col = 0 To colCnt - 1
				dscPos = colPos + colWdt(col) / 2.0
				Drawing.AddText dscPos, ortPntY + verDst, colDsc(col), dscTexPen, -1
				colPos = colPos + colWdt(col)
			Next col
			
			Drawing.CloseObject()		' zamknij obiekt
		End If
	End If
End Sub

